"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.CodeGenActionBtn = CodeGenActionBtn;
exports.fixSchema = fixSchema;
var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
require("./CodeGenActionBtn.scss");
var _react = _interopRequireWildcard(require("react"));
var CodeGenerator = _interopRequireWildcard(require("@alilc/lowcode-code-generator/standalone-loader"));
var _lowcodeTypes = require("@alilc/lowcode-types");
var _next = require("@alifd/next");
var _coerce = _interopRequireDefault(require("semver/functions/coerce"));
var _CodeGenResult = require("../CodeGenResult");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function CodeGenActionBtn(_ref) {
  var ctx = _ref.ctx,
    getAppProjectSchema = _ref.getAppProjectSchema;
  var _useState = (0, _react.useState)({
      visible: false,
      hasError: false,
      error: null,
      loading: false,
      result: null,
      schema: null,
      originalSchema: null
    }),
    state = _useState[0],
    setState = _useState[1];
  var handleClick = /*#__PURE__*/function () {
    var _ref2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
      var originalSchema, schema, result;
      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            _context.prev = 0;
            // 打开基于 Gravity 的编辑器/出码预览器
            setState(function (prev) {
              return (0, _extends2["default"])({}, prev, {
                loading: true,
                visible: true,
                hasError: false
              });
            });

            // 获取 schema，并修正
            _context.next = 4;
            return ctx.project.exportSchema(_lowcodeTypes.IPublicEnumTransformStage.Save);
          case 4:
            originalSchema = _context.sent;
            _context.next = 7;
            return fixSchema(originalSchema);
          case 7:
            schema = _context.sent;
            console.log('got schema: ', schema);
            setState(function (prev) {
              return (0, _extends2["default"])({}, prev, {
                schema: schema,
                originalSchema: originalSchema
              });
            });

            // 出码...
            _context.next = 12;
            return CodeGenerator.generateCode({
              solution: 'icejs',
              schema: schema,
              flattenResult: true
            });
          case 12:
            result = _context.sent;
            console.log('generated: ', result);
            setState(function (prev) {
              return (0, _extends2["default"])({}, prev, {
                loading: false,
                result: result
              });
            });
            _context.next = 21;
            break;
          case 17:
            _context.prev = 17;
            _context.t0 = _context["catch"](0);
            console.error('failed to run code generator: ', _context.t0);
            setState(function (prev) {
              return (0, _extends2["default"])({}, prev, {
                hasError: true,
                error: _context.t0 instanceof Error ? _context.t0 : new Error("" + ((_context.t0 === null || _context.t0 === void 0 ? void 0 : _context.t0.message) || _context.t0))
              });
            });
          case 21:
          case "end":
            return _context.stop();
        }
      }, _callee, null, [[0, 17]]);
    }));
    return function handleClick() {
      return _ref2.apply(this, arguments);
    };
  }();
  var appHandleClick = /*#__PURE__*/function () {
    var _ref3 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2() {
      var windows, i, originalSchema, schema, result;
      return _regenerator["default"].wrap(function _callee2$(_context2) {
        while (1) switch (_context2.prev = _context2.next) {
          case 0:
            _context2.prev = 0;
            // 打开基于 Gravity 的编辑器/出码预览器
            setState(function (prev) {
              return (0, _extends2["default"])({}, prev, {
                loading: true,
                visible: true,
                hasError: false
              });
            });

            // 保存
            windows = ctx.workspace.windows;
            i = 0;
          case 4:
            if (!(i < windows.length)) {
              _context2.next = 10;
              break;
            }
            _context2.next = 7;
            return windows[i].save();
          case 7:
            i++;
            _context2.next = 4;
            break;
          case 10:
            if (getAppProjectSchema) {
              _context2.next = 13;
              break;
            }
            console.error("options.getAppProjectSchema is required in workspace mode!");
            return _context2.abrupt("return");
          case 13:
            _context2.next = 15;
            return getAppProjectSchema(ctx);
          case 15:
            originalSchema = _context2.sent;
            if (originalSchema) {
              _context2.next = 19;
              break;
            }
            console.error("schema is invalid");
            return _context2.abrupt("return");
          case 19:
            _context2.next = 21;
            return fixSchema(originalSchema);
          case 21:
            schema = _context2.sent;
            console.log('got schema: ', schema);
            setState(function (prev) {
              return (0, _extends2["default"])({}, prev, {
                schema: schema,
                originalSchema: originalSchema
              });
            });

            // 出码...
            _context2.next = 26;
            return CodeGenerator.generateCode({
              solution: 'icejs',
              schema: schema,
              flattenResult: true
            });
          case 26:
            result = _context2.sent;
            console.log('generated: ', result);
            setState(function (prev) {
              return (0, _extends2["default"])({}, prev, {
                loading: false,
                result: result
              });
            });
            _context2.next = 35;
            break;
          case 31:
            _context2.prev = 31;
            _context2.t0 = _context2["catch"](0);
            console.error('failed to run code generator: ', _context2.t0);
            setState(function (prev) {
              return (0, _extends2["default"])({}, prev, {
                hasError: true,
                error: _context2.t0 instanceof Error ? _context2.t0 : new Error("" + ((_context2.t0 === null || _context2.t0 === void 0 ? void 0 : _context2.t0.message) || _context2.t0))
              });
            });
          case 35:
          case "end":
            return _context2.stop();
        }
      }, _callee2, null, [[0, 31]]);
    }));
    return function appHandleClick() {
      return _ref3.apply(this, arguments);
    };
  }();
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_next.Button, {
    type: "primary",
    onClick: ctx.registerLevel === _lowcodeTypes.IPublicEnumPluginRegisterLevel.Workspace ? appHandleClick : handleClick
  }, "\u51FA\u7801"), /*#__PURE__*/_react["default"].createElement(_next.Drawer, {
    visible: state.visible,
    title: "\u51FA\u7801\u7ED3\u679C",
    width: "95vw",
    onClose: function onClose() {
      setState(function (prev) {
        return (0, _extends2["default"])({}, prev, {
          visible: false
        });
      });
    }
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "code-gen-plugin-result"
  }, function () {
    if (state.hasError) {
      var _state$error;
      return /*#__PURE__*/_react["default"].createElement(_next.Message, {
        type: "error",
        title: "\u51FA\u9519\u4E86"
      }, (_state$error = state.error) === null || _state$error === void 0 ? void 0 : _state$error.message);
    }
    if (state.loading) {
      return /*#__PURE__*/_react["default"].createElement(_next.Loading, {
        className: "code-gen-plugin-loading",
        tip: "\u6B63\u5728\u51FA\u7801..."
      });
    }
    return /*#__PURE__*/_react["default"].createElement(_CodeGenResult.CodeGenResult, {
      result: state.result,
      schema: state.schema,
      originalSchema: state.originalSchema
    });
  }())));
}
function fixSchema(_x) {
  return _fixSchema.apply(this, arguments);
}
function _fixSchema() {
  _fixSchema = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3(schema) {
    return _regenerator["default"].wrap(function _callee3$(_context3) {
      while (1) switch (_context3.prev = _context3.next) {
        case 0:
          return _context3.abrupt("return", deepClone((0, _extends2["default"])({}, schema, {
            componentsMap: schema.componentsMap.filter(function (c) {
              return c["package"];
            }) // 去掉没有 package 的组件
            .map(function (c) {
              // 修正版本号（对于没有有效版本号的组件，默认使用 latest）
              if (!isValidVersion(c.version)) {
                console.warn('[WARN] got invalid version "%o" for component "%s", use "latest" as fallback', c.version, c);
                return (0, _extends2["default"])({}, c, {
                  version: 'latest'
                });
              }

              // 修正 @alifd/pro-layout 的版本
              // -- 这个包没有 ^0.1.0 的版本，这里暂且替换下
              if (c["package"] === '@alifd/pro-layout' && c.version === '^0.1.0') {
                console.warn('[WARN] got invalid version "%o" for "@alifd/pro-layout"! use "latest" as fallback', c.version);
                return (0, _extends2["default"])({}, c, {
                  version: 'latest'
                });
              }
              return c;
            })
          })));
        case 1:
        case "end":
          return _context3.stop();
      }
    }, _callee3);
  }));
  return _fixSchema.apply(this, arguments);
}
function deepClone(x) {
  try {
    return JSON.parse(JSON.stringify(x));
  } catch (e) {
    throw new Error("failed to clone schema -- " + e);
  }
}
function isValidVersion(version) {
  if (!version) {
    return false;
  }

  // 对于一些明显非法的版本号过滤下
  if (version === '{{version}}' || version === 'null' || version === 'undefined') {
    return false;
  }

  // 对于 latest/beta/rc 这样的 tag 版本号要支持下
  if (/^[a-z][a-z0-9]+([a-z0-9-]+)?$/i.test(version)) {
    return true;
  }

  // 最后支持下所有 semver 能识别的版本
  return (0, _coerce["default"])(version) !== null;
}